Index: /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComPrediction.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComPrediction.cpp	(revision 427)
@@ -927,4 +927,5 @@
   if (vspIdx != 0)
   {
+#if !QC_BVSP_CleanUP_D0191
     if (iRefIdx >= 0)
     {
@@ -932,4 +933,5 @@
     }
     assert (iRefIdx < 0); // assert (iRefIdx == NOT_VALID);
+#endif
   }
   else
@@ -1784,6 +1786,11 @@
   Int dstStride = dstPic->getStride();
   Int depStride =  pPicBaseDepth->getStride();
+#if LGE_ROUND_OFFSET_D0135
+  Int depthPosX = Clip3(0,   widthLuma - sizeX,  (posX/nTxtPerDepthX) + ((mv->getHor()+2)>>2));
+  Int depthPosY = Clip3(0,   heightLuma- sizeY,  (posY/nTxtPerDepthY) + ((mv->getVer()+2)>>2));
+#else
   Int depthPosX = Clip3(0,   widthLuma - sizeX,  (posX/nTxtPerDepthX) + (mv->getHor()>>2));
   Int depthPosY = Clip3(0,   heightLuma- sizeY,  (posY/nTxtPerDepthY) + (mv->getVer()>>2));
+#endif
   Pel *ref    = refPic->getLumaAddr() + posX + posY * refStride;
   Pel *dst    = dstPic->getLumaAddr(partAddr);
@@ -2034,5 +2041,9 @@
     nTxtPerDepthX = widthChroma / widthDepth;
     nDepthPerTxtX = 1;
+#if LGE_ROUND_OFFSET_D0135
+    depthPosX = posX / nTxtPerDepthX + ((mv->getHor()+2)>>2);        //mv denotes the disparity for VSP
+#else
     depthPosX = posX / nTxtPerDepthX + (mv->getHor()>>2);        //mv denotes the disparity for VSP
+#endif
   }
   else
@@ -2040,5 +2051,9 @@
     nTxtPerDepthX = 1;
     nDepthPerTxtX = widthDepth / widthChroma;
+#if LGE_ROUND_OFFSET_D0135
+    depthPosX = posX * nDepthPerTxtX + ((mv->getHor()+2)>>2);        //mv denotes the disparity for VSP
+#else
     depthPosX = posX * nDepthPerTxtX + (mv->getHor()>>2);        //mv denotes the disparity for VSP
+#endif
   }
   depthPosX = Clip3(0, widthDepth - (sizeX<<1), depthPosX);
@@ -2047,5 +2062,9 @@
     nTxtPerDepthY = heightChroma / heightDepth;
     nDepthPerTxtY = 1;
+#if LGE_ROUND_OFFSET_D0135
+    depthPosY = posY / nTxtPerDepthY + ((mv->getVer()+2)>>2);     //mv denotes the disparity for VSP
+#else
     depthPosY = posY / nTxtPerDepthY + (mv->getVer()>>2);     //mv denotes the disparity for VSP
+#endif
   }
   else
@@ -2053,5 +2072,9 @@
     nTxtPerDepthY = 1;
     nDepthPerTxtY = heightDepth / heightChroma;
+#if LGE_ROUND_OFFSET_D0135
+    depthPosY = posY * nDepthPerTxtY + ((mv->getVer()+2)>>2);     //mv denotes the disparity for VSP
+#else
     depthPosY = posY * nDepthPerTxtY + (mv->getVer()>>2);     //mv denotes the disparity for VSP
+#endif
   }
   depthPosY = Clip3(0, heightDepth - (sizeY<<1), depthPosY);
@@ -2764,6 +2787,11 @@
   iCUPelX = pcCU->getCUPelX() + g_auiRasterToPelX[g_auiZscanToRaster[pcCU->getZorderIdxInCU()]];
   iCUPelY = pcCU->getCUPelY() + g_auiRasterToPelY[g_auiZscanToRaster[pcCU->getZorderIdxInCU()]];
+#if LGE_ROUND_OFFSET_D0135
+  iRefX   = iCUPelX + ((pMv->getHor()+2) >> 2);
+  iRefY   = iCUPelY + ((pMv->getVer()+2) >> 2);
+#else
   iRefX   = iCUPelX + (pMv->getHor() >> 2);
   iRefY   = iCUPelY + (pMv->getVer() >> 2);
+#endif
   uiWidth = pcCU->getWidth(0);
   uiHeight = pcCU->getHeight(0);
@@ -2777,5 +2805,9 @@
   if(pcCU->getPUAbove(uiTmpPartIdx, pcCU->getZorderIdxInCU()) && iCUPelY > 0 && iRefY > 0)
   {
+#if LGE_ROUND_OFFSET_D0135
+    iRefOffset = ( (pMv->getHor()+2) >> 2 ) + ( (pMv->getVer()+2) >> 2 ) * iRefStride - iRefStride;
+#else
     iRefOffset = ( pMv->getHor() >> 2 ) + ( pMv->getVer() >> 2 ) * iRefStride - iRefStride;
+#endif
     pRef = pRefPic->getLumaAddr( pcCU->getAddr(), pcCU->getZorderIdxInCU() ) + iRefOffset;
     pRec = pRecPic->getLumaAddr( pcCU->getAddr(), pcCU->getZorderIdxInCU() ) - iRecStride;
@@ -2794,5 +2826,9 @@
   if(pcCU->getPULeft(uiTmpPartIdx, pcCU->getZorderIdxInCU()) && iCUPelX > 0 && iRefX > 0)
   {
+#if LGE_ROUND_OFFSET_D0135
+    iRefOffset = ( (pMv->getHor()+2) >> 2 ) + ( (pMv->getVer()+2) >> 2 ) * iRefStride - 1;
+#else
     iRefOffset = ( pMv->getHor() >> 2 ) + ( pMv->getVer() >> 2 ) * iRefStride - 1;
+#endif
     pRef = pRefPic->getLumaAddr( pcCU->getAddr(), pcCU->getZorderIdxInCU() ) + iRefOffset;
     pRec = pRecPic->getLumaAddr( pcCU->getAddr(), pcCU->getZorderIdxInCU() ) - 1;
@@ -2912,6 +2948,11 @@
   iCUPelX = pcCU->getCUPelX() + g_auiRasterToPelX[g_auiZscanToRaster[pcCU->getZorderIdxInCU()]];
   iCUPelY = pcCU->getCUPelY() + g_auiRasterToPelY[g_auiZscanToRaster[pcCU->getZorderIdxInCU()]];
+#if LGE_ROUND_OFFSET_D0135
+  iRefX   = iCUPelX + ((pMv->getHor()+2) >> 2);
+  iRefY   = iCUPelY + ((pMv->getVer()+2) >> 2);
+#else
   iRefX   = iCUPelX + (pMv->getHor() >> 2);
   iRefY   = iCUPelY + (pMv->getVer() >> 2);
+#endif
   uiWidth = pcCU->getWidth(0) >> 1;
   uiHeight = pcCU->getHeight(0) >> 1;
@@ -2925,5 +2966,9 @@
   if(pcCU->getPUAbove(uiTmpPartIdx, pcCU->getZorderIdxInCU()) && iCUPelY > 0 && iRefY > 0)
   {
+#if LGE_ROUND_OFFSET_D0135
+    iRefOffset = ( (pMv->getHor()+4) >> 3 ) + ( (pMv->getVer()+4) >> 3 ) * iRefStride - iRefStride;
+#else
     iRefOffset = ( pMv->getHor() >> 3 ) + ( pMv->getVer() >> 3 ) * iRefStride - iRefStride;
+#endif
     if (iChromaId == 0) // Cb
     {
@@ -2950,5 +2995,9 @@
   if(pcCU->getPULeft(uiTmpPartIdx, pcCU->getZorderIdxInCU()) && iCUPelX > 0 && iRefX > 0)
   {
+#if LGE_ROUND_OFFSET_D0135
+    iRefOffset = ( (pMv->getHor()+4) >> 3 ) + ( (pMv->getVer()+4) >> 3 ) * iRefStride - 1;
+#else
     iRefOffset = ( pMv->getHor() >> 3 ) + ( pMv->getVer() >> 3 ) * iRefStride - 1;
+#endif
     if (iChromaId == 0) // Cb
     {
Index: /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp	(revision 427)
@@ -62,5 +62,7 @@
 TComSampleAdaptiveOffset::TComSampleAdaptiveOffset()
 {
+#if !LGE_SAO_MIGRATION_D0091
   m_pcPic = NULL;
+#endif
   m_iOffsetBo = NULL;
   m_pClipTable = NULL;
@@ -71,5 +73,7 @@
   m_iUpBufft = NULL;
   ipSwap = NULL;
+#if !LGE_SAO_MIGRATION_D0091
   m_pcYuvTmp = NULL;
+#endif
 
   m_pTmpU1 = NULL;
@@ -85,4 +89,5 @@
 }
 
+#if !LGE_SAO_MIGRATION_D0091
 const Int TComSampleAdaptiveOffset::m_aiNumPartsInRow[5] =
 {
@@ -102,4 +107,5 @@
   256  //level 4
 };
+#endif
 
 const Int TComSampleAdaptiveOffset::m_aiNumCulPartsLevel[5] =
@@ -124,5 +130,5 @@
   0
 };
-
+#if !LGE_SAO_MIGRATION_D0091
 const UInt TComSampleAdaptiveOffset::m_iWeightSao[MAX_NUM_SAO_TYPE] =
 {
@@ -146,4 +152,5 @@
   6
 };
+#endif
 
 Int TComSampleAdaptiveOffset::m_iNumClass[MAX_NUM_SAO_TYPE] =
@@ -187,4 +194,5 @@
   return idx;
 }
+#if !LGE_SAO_MIGRATION_D0091
 /** convert quadtree Idx to Level, Row, and Col
  * \param  idx,  *level,  *row,  *col
@@ -223,4 +231,5 @@
   }
 }
+#endif
 /** create SampleAdaptiveOffset memory.
  * \param 
@@ -317,5 +326,21 @@
   }
 
-
+#if LGE_SAO_MIGRATION_D0091
+  if (m_iUpBuff1)
+  {
+      m_iUpBuff1--;
+      delete [] m_iUpBuff1; m_iUpBuff1 = NULL;
+  }
+  if (m_iUpBuff2)
+  {
+      m_iUpBuff2--;
+      delete [] m_iUpBuff2; m_iUpBuff2 = NULL;
+  }
+  if (m_iUpBufft)
+  {
+      m_iUpBufft--;
+      delete [] m_iUpBufft; m_iUpBufft = NULL;
+  }
+#else
   m_iUpBuff1--;
   m_iUpBuff2--;
@@ -334,4 +359,5 @@
     delete [] m_iUpBufft; m_iUpBufft = NULL;
   }
+#endif
   if (m_pTmpL1)
   {
@@ -368,8 +394,10 @@
   initSAOParam(pcSaoParam, 0, 0, 0, -1, 0, m_iNumCuInWidth-1,  0, m_iNumCuInHeight-1,1);
   initSAOParam(pcSaoParam, 0, 0, 0, -1, 0, m_iNumCuInWidth-1,  0, m_iNumCuInHeight-1,2);
+#if !LGE_SAO_MIGRATION_D0091
   for(Int j=0;j<MAX_NUM_SAO_TYPE;j++)
   {
     pcSaoParam->iNumClass[j] = m_iNumClass[j];
   }
+#endif
   pcSaoParam->numCuInWidth  = m_iNumCuInWidth;
   pcSaoParam->numCuInHeight = m_iNumCuInHeight;
@@ -405,5 +433,9 @@
   pSaoPart->iLength     =  0;
 
+#if LGE_SAO_MIGRATION_D0091
+  pSaoPart->subTypeIdx = 0;
+#else
   pSaoPart->bandPosition = 0;
+#endif
 
   for (j=0;j<MAX_NUM_SAO_OFFSETS;j++)
@@ -514,5 +546,12 @@
   for(Int c=0; c<iNumComponet; c++)
   {
+#if LGE_SAO_MIGRATION_D0091
+    if (c<2)
+    {
     pcSaoParam->bSaoFlag[c] = 0;
+    }
+#else
+    pcSaoParam->bSaoFlag[c] = 0;
+#endif
     for(Int i=0; i< m_aiNumCulPartsLevel[m_uiMaxSplitLevel]; i++)
     {
@@ -524,5 +563,9 @@
       pcSaoParam->psSaoPart[c][i].iMinDist      = MAX_INT;
       pcSaoParam->psSaoPart[c][i].iMinRate      = MAX_INT;
+#if LGE_SAO_MIGRATION_D0091
+      pcSaoParam->psSaoPart[c][i].subTypeIdx    = 0;
+#else
       pcSaoParam->psSaoPart[c][i].bandPosition = 0;
+#endif
       for (Int j=0;j<MAX_NUM_SAO_OFFSETS;j++)
       {
@@ -557,5 +600,9 @@
   m_pcPic   = pcPic;
   m_uiNumSlicesInPic = numSlicesInPic;
+#if LGE_SAO_MIGRATION_D0091
+  m_iSGDepth         = 0;
+#else
   m_iSGDepth         = pcPic->getSliceGranularityForNDBFilter();
+#endif
   m_bUseNIF = ( pcPic->getIndependentSliceBoundaryForNDBFilter() || pcPic->getIndependentTileBoundaryForNDBFilter() );
   if(m_bUseNIF)
@@ -958,5 +1005,4 @@
           uiEdgeType = iSignDown + m_iUpBuff1[x] + 2;
           m_iUpBuff1[x]= -iSignDown;
-
           pRec[x] = m_pClipTable[pRec[x] + m_iOffsetEo[uiEdgeType]];
         }
@@ -1065,5 +1111,9 @@
 Void TComSampleAdaptiveOffset::SAOProcess(TComPic* pcPic, SAOParam* pcSaoParam)
 {
+#if LGE_SAO_MIGRATION_D0091
+  if (pcSaoParam->bSaoFlag[0] || pcSaoParam->bSaoFlag[1])
+#else
   if (pcSaoParam->bSaoFlag[0])
+#endif
   {
 #if FULL_NBIT
@@ -1077,6 +1127,9 @@
       m_pcPic->getPicYuvRec()->copyToPic(m_pcYuvTmp);
     }
-
+#if LGE_SAO_MIGRATION_D0091
+    if (m_saoLcuBasedOptimization)
+#else
     if (m_saoInterleavingFlag)
+#endif
     {
       pcSaoParam->oneUnitFlag[0] = 0;  
@@ -1085,4 +1138,15 @@
     }
     Int iY  = 0;
+#if LGE_SAO_MIGRATION_D0091
+    if (pcSaoParam->bSaoFlag[0])
+    {
+        processSaoUnitAll( pcSaoParam->saoLcuParam[iY], pcSaoParam->oneUnitFlag[iY], iY);
+    }
+    if(pcSaoParam->bSaoFlag[1])
+    {
+        processSaoUnitAll( pcSaoParam->saoLcuParam[1], pcSaoParam->oneUnitFlag[1], 1);//Cb
+        processSaoUnitAll( pcSaoParam->saoLcuParam[2], pcSaoParam->oneUnitFlag[2], 2);//Cr
+    }
+#else
     processSaoUnitAll( pcSaoParam->saoLcuParam[iY], pcSaoParam->oneUnitFlag[iY], iY);
 
@@ -1097,6 +1161,5 @@
       processSaoUnitAll( pcSaoParam->saoLcuParam[iCr], pcSaoParam->oneUnitFlag[iCr], iCr);
     }
-
-
+#endif
     m_pcPic = NULL;
   }
@@ -1154,5 +1217,9 @@
   Int  typeIdx;
 
+#if LGE_SAO_MIGRATION_D0091
+  Int offset[LUMA_GROUP_NUM+1];
+#else
   static Int offset[LUMA_GROUP_NUM+1];
+#endif
   Int idxX;
   Int idxY;
@@ -1164,6 +1231,7 @@
   Int isChroma = (yCbCr == 0) ? 0:1;
   Bool mergeLeftFlag;
-
-
+#if LGE_SAO_MIGRATION_D0091
+  offset[0] = 0;
+#endif
   for (idxY = 0; idxY< frameHeightInCU; idxY++)
   { 
@@ -1201,5 +1269,4 @@
     {
       addr = idxY * frameWidthInCU + idxX;
-
       if (oneUnitFlag)
       {
@@ -1225,5 +1292,9 @@
             for (i=0; i<saoLcuParam[addr].length; i++)
             {
+#if LGE_SAO_MIGRATION_D0091
+              offset[ (saoLcuParam[addr].subTypeIdx +i)%SAO_MAX_BO_CLASSES  +1] = saoLcuParam[addr].offset[i] << m_uiSaoBitIncrease;
+#else
               offset[ (saoLcuParam[addr].bandPosition +i)%SAO_MAX_BO_CLASSES  +1] = saoLcuParam[addr].offset[i] << m_uiSaoBitIncrease;
+#endif
             }
 
@@ -1304,5 +1375,9 @@
       saoLcuParam[i].offset[j] = 0;
     }
+#if LGE_SAO_MIGRATION_D0091
+    saoLcuParam[i].subTypeIdx   = 0;
+#else
     saoLcuParam[i].bandPosition = 0;
+#endif
   }
 }
@@ -1353,5 +1428,9 @@
       saoLcuParam[addr].partIdxTmp = (Int)partIdx; 
       saoLcuParam[addr].typeIdx    = saoQTPart[partIdx].iBestType;
+#if LGE_SAO_MIGRATION_D0091
+      saoLcuParam[addr].subTypeIdx   = saoQTPart[partIdx].subTypeIdx;
+#else
       saoLcuParam[addr].bandPosition = saoQTPart[partIdx].bandPosition;
+#endif
       if (saoLcuParam[addr].typeIdx!=-1)
       {
@@ -1365,5 +1444,9 @@
       {
         saoLcuParam[addr].length    = 0;
+#if LGE_SAO_MIGRATION_D0091
+        saoLcuParam[addr].subTypeIdx = saoQTPart[partIdx].subTypeIdx;
+#else
         saoLcuParam[addr].bandPosition = saoQTPart[partIdx].bandPosition;
+#endif
         for (j=0;j<MAX_NUM_SAO_OFFSETS;j++)
         {
@@ -1375,5 +1458,174 @@
 }
 
-
-
+#if LGE_SAO_MIGRATION_D0091
+Void TComSampleAdaptiveOffset::resetSaoUnit(SaoLcuParam* saoUnit)
+{
+  saoUnit->partIdx       = 0;
+  saoUnit->partIdxTmp    = 0;
+  saoUnit->mergeLeftFlag = 0;
+  saoUnit->mergeUpFlag   = 0;
+  saoUnit->typeIdx       = -1;
+  saoUnit->length        = 0;
+  saoUnit->subTypeIdx    = 0;
+
+  for (Int i=0;i<4;i++)
+  {
+    saoUnit->offset[i] = 0;
+  }
+}
+
+Void TComSampleAdaptiveOffset::copySaoUnit(SaoLcuParam* saoUnitDst, SaoLcuParam* saoUnitSrc )
+{
+  saoUnitDst->mergeLeftFlag = saoUnitSrc->mergeLeftFlag;
+  saoUnitDst->mergeUpFlag   = saoUnitSrc->mergeUpFlag;
+  saoUnitDst->typeIdx       = saoUnitSrc->typeIdx;
+  saoUnitDst->length        = saoUnitSrc->length;
+
+  saoUnitDst->subTypeIdx  = saoUnitSrc->subTypeIdx;
+  for (Int i=0;i<4;i++)
+  {
+    saoUnitDst->offset[i] = saoUnitSrc->offset[i];
+  }
+}
+
+/** PCM LF disable process. 
+ * \param pcPic picture (TComPic) pointer
+ * \returns Void
+ *
+ * \note Replace filtered sample values of PCM mode blocks with the transmitted and reconstructed ones.
+ */
+Void TComSampleAdaptiveOffset::PCMLFDisableProcess (TComPic* pcPic)
+{
+  xPCMRestoration(pcPic);
+}
+
+/** Picture-level PCM restoration. 
+ * \param pcPic picture (TComPic) pointer
+ * \returns Void
+ */
+Void TComSampleAdaptiveOffset::xPCMRestoration(TComPic* pcPic)
+{
+  Bool  bPCMFilter = (pcPic->getSlice(0)->getSPS()->getUsePCM() && pcPic->getSlice(0)->getSPS()->getPCMFilterDisableFlag())? true : false;
+#if LOSSLESS_CODING
+  if(bPCMFilter || pcPic->getSlice(0)->getSPS()->getUseLossless())
+#else
+  if(bPCMFilter)
+#endif
+  {
+      for( UInt uiCUAddr = 0; uiCUAddr < pcPic->getNumCUsInFrame() ; uiCUAddr++ )
+      {
+          TComDataCU* pcCU = pcPic->getCU(uiCUAddr);
+          xPCMCURestoration(pcCU, 0, 0); 
+      } 
+  }
+}
+
+/** PCM CU restoration. 
+ * \param pcCU pointer to current CU
+ * \param uiAbsPartIdx part index
+ * \param uiDepth CU depth
+ * \returns Void
+ */
+Void TComSampleAdaptiveOffset::xPCMCURestoration ( TComDataCU* pcCU, UInt uiAbsZorderIdx, UInt uiDepth )
+{
+  TComPic* pcPic     = pcCU->getPic();
+  UInt uiCurNumParts = pcPic->getNumPartInCU() >> (uiDepth<<1);
+  UInt uiQNumParts   = uiCurNumParts>>2;
+
+  // go to sub-CU
+  if( pcCU->getDepth(uiAbsZorderIdx) > uiDepth )
+  {
+    for ( UInt uiPartIdx = 0; uiPartIdx < 4; uiPartIdx++, uiAbsZorderIdx+=uiQNumParts )
+    {
+      UInt uiLPelX   = pcCU->getCUPelX() + g_auiRasterToPelX[ g_auiZscanToRaster[uiAbsZorderIdx] ];
+      UInt uiTPelY   = pcCU->getCUPelY() + g_auiRasterToPelY[ g_auiZscanToRaster[uiAbsZorderIdx] ];
+      if( ( uiLPelX < pcCU->getSlice()->getSPS()->getPicWidthInLumaSamples() ) && ( uiTPelY < pcCU->getSlice()->getSPS()->getPicHeightInLumaSamples() ) )
+        xPCMCURestoration( pcCU, uiAbsZorderIdx, uiDepth+1 );
+    }
+    return;
+  }
+
+  // restore PCM samples
+  if ((pcCU->getIPCMFlag(uiAbsZorderIdx)&& pcPic->getSlice(0)->getSPS()->getPCMFilterDisableFlag()) || pcCU->isLosslessCoded( uiAbsZorderIdx))
+  {
+    xPCMSampleRestoration (pcCU, uiAbsZorderIdx, uiDepth, TEXT_LUMA    );
+    xPCMSampleRestoration (pcCU, uiAbsZorderIdx, uiDepth, TEXT_CHROMA_U);
+    xPCMSampleRestoration (pcCU, uiAbsZorderIdx, uiDepth, TEXT_CHROMA_V);
+  }
+}
+
+/** PCM sample restoration. 
+ * \param pcCU pointer to current CU
+ * \param uiAbsPartIdx part index
+ * \param uiDepth CU depth
+ * \param ttText texture component type
+ * \returns Void
+ */
+Void TComSampleAdaptiveOffset::xPCMSampleRestoration (TComDataCU* pcCU, UInt uiAbsZorderIdx, UInt uiDepth, TextType ttText)
+{
+  TComPicYuv* pcPicYuvRec = pcCU->getPic()->getPicYuvRec();
+  Pel* piSrc;
+  Pel* piPcm;
+  UInt uiStride;
+  UInt uiWidth;
+  UInt uiHeight;
+  UInt uiPcmLeftShiftBit; 
+  UInt uiX, uiY;
+  UInt uiMinCoeffSize = pcCU->getPic()->getMinCUWidth()*pcCU->getPic()->getMinCUHeight();
+  UInt uiLumaOffset   = uiMinCoeffSize*uiAbsZorderIdx;
+  UInt uiChromaOffset = uiLumaOffset>>2;
+
+  if( ttText == TEXT_LUMA )
+  {
+    piSrc = pcPicYuvRec->getLumaAddr( pcCU->getAddr(), uiAbsZorderIdx);
+    piPcm = pcCU->getPCMSampleY() + uiLumaOffset;
+    uiStride  = pcPicYuvRec->getStride();
+    uiWidth  = (g_uiMaxCUWidth >> uiDepth);
+    uiHeight = (g_uiMaxCUHeight >> uiDepth);
+    if ( pcCU->isLosslessCoded(uiAbsZorderIdx) )
+    {
+      uiPcmLeftShiftBit = 0;
+    }
+    else
+    {
+        uiPcmLeftShiftBit = g_uiBitDepth + g_uiBitIncrement - pcCU->getSlice()->getSPS()->getPCMBitDepthLuma();
+    }
+  }
+  else
+  {
+    if( ttText == TEXT_CHROMA_U )
+    {
+      piSrc = pcPicYuvRec->getCbAddr( pcCU->getAddr(), uiAbsZorderIdx );
+      piPcm = pcCU->getPCMSampleCb() + uiChromaOffset;
+    }
+    else
+    {
+      piSrc = pcPicYuvRec->getCrAddr( pcCU->getAddr(), uiAbsZorderIdx );
+      piPcm = pcCU->getPCMSampleCr() + uiChromaOffset;
+    }
+
+    uiStride = pcPicYuvRec->getCStride();
+    uiWidth  = ((g_uiMaxCUWidth >> uiDepth)/2);
+    uiHeight = ((g_uiMaxCUWidth >> uiDepth)/2);
+    if ( pcCU->isLosslessCoded(uiAbsZorderIdx) )
+    {
+      uiPcmLeftShiftBit = 0;
+    }
+    else
+    {
+      uiPcmLeftShiftBit = g_uiBitDepth + g_uiBitIncrement - pcCU->getSlice()->getSPS()->getPCMBitDepthChroma();
+    }
+  }
+
+  for( uiY = 0; uiY < uiHeight; uiY++ )
+  {
+    for( uiX = 0; uiX < uiWidth; uiX++ )
+    {
+      piSrc[uiX] = (piPcm[uiX] << uiPcmLeftShiftBit);
+    }
+    piPcm += uiWidth;
+    piSrc += uiStride;
+  }
+}
+#endif
 //! \}
Index: /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h	(revision 427)
@@ -65,10 +65,14 @@
 
   static UInt m_uiMaxDepth;
+#if !LGE_SAO_MIGRATION_D0091
   static const Int m_aiNumPartsInRow[5];
   static const Int m_aiNumPartsLevel[5];
+#endif
   static const Int m_aiNumCulPartsLevel[5];
   static const UInt m_auiEoTable[9];
+#if !LGE_SAO_MIGRATION_D0091
   static const UInt m_auiEoTable2D[9];
   static const UInt m_iWeightSao[MAX_NUM_SAO_TYPE];
+#endif
   Int *m_iOffsetBo;
   Int m_iOffsetEo[LUMA_GROUP_NUM];
@@ -107,5 +111,14 @@
   Int* m_iLcuPartIdx;
   Int     m_maxNumOffsetsPerPic;
+#if LGE_SAO_MIGRATION_D0091
+  Bool    m_saoLcuBoundary;
+  Bool    m_saoLcuBasedOptimization;
+
+  Void xPCMRestoration        (TComPic* pcPic);
+  Void xPCMCURestoration      (TComDataCU* pcCU, UInt uiAbsZorderIdx, UInt uiDepth);
+  Void xPCMSampleRestoration  (TComDataCU* pcCU, UInt uiAbsZorderIdx, UInt uiDepth, TextType ttText);
+#else
   Bool    m_saoInterleavingFlag;
+#endif
 public:
   TComSampleAdaptiveOffset         ();
@@ -116,15 +129,24 @@
 
   Int  convertLevelRowCol2Idx(int level, int row, int col);
+#if !LGE_SAO_MIGRATION_D0091
   void convertIdx2LevelRowCol(int idx, int *level, int *row, int *col);
+#endif
 
   Void initSAOParam   (SAOParam *pcSaoParam, Int iPartLevel, Int iPartRow, Int iPartCol, Int iParentPartIdx, Int StartCUX, Int EndCUX, Int StartCUY, Int EndCUY, Int iYCbCr);
   Void allocSaoParam  (SAOParam* pcSaoParam);
   Void resetSAOParam  (SAOParam *pcSaoParam);
+#if LGE_SAO_MIGRATION_D0091
+  static Void freeSaoParam   (SAOParam *pcSaoParam);
+#else
   Void freeSaoParam   (SAOParam *pcSaoParam);
+#endif
+  
 
   Void SAOProcess(TComPic* pcPic, SAOParam* pcSaoParam);
   Void processSaoCu(Int iAddr, Int iSaoType, Int iYCbCr);
+#if !LGE_SAO_MIGRATION_D0091
   Void processSaoOnePart(SAOQTPart *psQTPart, UInt uiPartIdx, Int iYCbCr);
   Void processSaoQuadTree(SAOQTPart *psQTPart, UInt uiPartIdx, Int iYCbCr);
+#endif
   Pel* getPicYuvAddr(TComPicYuv* pcPicYuv, Int iYCbCr,Int iAddr = 0);
 
@@ -138,6 +160,16 @@
   Void convertOnePart2SaoUnit(SAOParam *saoParam, UInt partIdx, Int yCbCr);
   Void processSaoUnitAll(SaoLcuParam* saoLcuParam, Bool oneUnitFlag, Int yCbCr);
+#if LGE_SAO_MIGRATION_D0091
+  Void setSaoLcuBoundary (Bool bVal)  {m_saoLcuBoundary = bVal;}
+  Bool getSaoLcuBoundary ()           {return m_saoLcuBoundary;}
+  Void setSaoLcuBasedOptimization (Bool bVal)  {m_saoLcuBasedOptimization = bVal;}
+  Bool getSaoLcuBasedOptimization ()           {return m_saoLcuBasedOptimization;}
+  Void resetSaoUnit(SaoLcuParam* saoUnit);
+  Void copySaoUnit(SaoLcuParam* saoUnitDst, SaoLcuParam* saoUnitSrc );
+  Void PCMLFDisableProcess    ( TComPic* pcPic);                        ///< interface function for ALF process 
+#else
   Void setSaoInterleavingFlag (Bool bVal)  {m_saoInterleavingFlag = bVal;}
   Bool getSaoInterleavingFlag ()           {return m_saoInterleavingFlag;}
+#endif
 };
 
Index: /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 427)
@@ -113,4 +113,7 @@
 #if LGE_ILLUCOMP_B0045
 , m_bApplyIC                      ( false )
+#if SHARP_ILLUCOMP_PARSE_D0060
+, m_icSkipParseFlag               ( false )
+#endif
 #endif
 #if INTER_VIEW_VECTOR_SCALING_C0115
@@ -822,7 +825,11 @@
 
   m_saoEnabledFlag = pSrc->m_saoEnabledFlag; 
+#if LGE_SAO_MIGRATION_D0091
+  m_saoEnabledFlagChroma = pSrc->m_saoEnabledFlagChroma;
+#else
   m_saoInterleavingFlag = pSrc->m_saoInterleavingFlag;
   m_saoEnabledFlagCb = pSrc->m_saoEnabledFlagCb;
   m_saoEnabledFlagCr = pSrc->m_saoEnabledFlagCr; 
+#endif
 #if CABAC_INIT_FLAG
   m_cabacInitFlag                = pSrc->m_cabacInitFlag;
@@ -831,4 +838,8 @@
 
   m_bLMvdL1Zero = pSrc->m_bLMvdL1Zero;
+#if SHARP_ILLUCOMP_PARSE_D0060
+  m_bApplyIC = pSrc->m_bApplyIC;
+  m_icSkipParseFlag = pSrc->m_icSkipParseFlag;
+#endif
 }
 
@@ -2109,5 +2120,7 @@
   m_scalingList = src.m_scalingList;
   m_scalingListEnabled = src.m_scalingListEnabled;
+#if !LGE_SAO_MIGRATION_D0091
   m_saoInterleavingFlag = src.m_saoInterleavingFlag;
+#endif
 
   return *this;
Index: /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 427)
@@ -180,4 +180,12 @@
   Bool          m_bIVScalingFlag;
 #endif
+
+#if MTK_D0156
+#if MERL_VSP_COMPENSATION_C0152
+  Bool      m_abUseVSPCompensation[ MAX_TLAYER ];
+#endif
+  Bool      m_abUseDVPRefine[ MAX_TLAYER ];
+#endif
+
 public:
   TComVPS();
@@ -245,4 +253,13 @@
   
 #endif 
+
+#if MTK_D0156
+#if MERL_VSP_COMPENSATION_C0152
+  Bool    getUseVSPCompensation( UInt tLayer ){  return m_abUseVSPCompensation[ tLayer ];}
+  Void    setUseVSPCompensation( Bool bValue, UInt tLayer ){ m_abUseVSPCompensation[ tLayer ] = bValue;}
+#endif
+  Bool    getUseDVPRefine( UInt tLayer ){  return m_abUseDVPRefine[ tLayer ];}
+  Void    setUseDVPRefine( Bool bValue, UInt tLayer ){ m_abUseDVPRefine[ tLayer ] = bValue;}
+#endif
 };
 
@@ -403,4 +420,11 @@
 #if H3D_IVRP & !QC_ARP_D0177
   TComResidualGenerator* m_pcResidualGenerator;
+#endif
+
+#if MTK_D0156
+#if MERL_VSP_COMPENSATION_C0152
+  Bool      m_bUseVSPCompensation;
+#endif
+  Bool      m_bUseDVPRefine;
 #endif
 
@@ -681,4 +705,16 @@
   TComResidualGenerator*  getResidualGenerator()                                              { return m_pcResidualGenerator; }
 #endif
+
+#if MTK_D0156
+
+#if MERL_VSP_COMPENSATION_C0152
+  Bool    getUseVSPCompensation( ){  return m_bUseVSPCompensation;}
+  Void    setUseVSPCompensation( Bool bValue ){ m_bUseVSPCompensation = bValue;}
+#endif
+
+  Bool    getUseDVPRefine( ){  return m_bUseDVPRefine;}
+  Void    setUseDVPRefine( Bool bValue ){ m_bUseDVPRefine = bValue;}
+
+#endif
 };
 
@@ -940,6 +976,8 @@
   Bool      getScalingListEnabled ()          { return m_scalingListEnabled; }  //!< get ScalingList enabled/disabled in APS
   TComScalingList* getScalingList ()          { return m_scalingList; }         //!< get ScalingList class pointer in APS
+#if !LGE_SAO_MIGRATION_D0091
   Bool     getSaoInterleavingFlag() {return m_saoInterleavingFlag;}             //!< get SAO interleaving flag in APS
   Void     setSaoInterleavingFlag(Bool bVal) {m_saoInterleavingFlag = bVal;}    //!< set SAO interleaving flag in APS
+#endif
 
 private:
@@ -955,5 +993,7 @@
   Bool        m_scalingListEnabled;     //!< ScalingList enabled/disabled in APS (true for enabled)
   TComScalingList*     m_scalingList;   //!< ScalingList class pointer
+#if !LGE_SAO_MIGRATION_D0091
   Bool        m_saoInterleavingFlag;    //!< SAO interleaving flag
+#endif
 
 public:
@@ -987,7 +1027,11 @@
   bool       m_alfEnabledFlag;
   bool       m_saoEnabledFlag;
+#if LGE_SAO_MIGRATION_D0091
+  bool       m_saoEnabledFlagChroma;      ///< SAO Cb&Cr enabled flag
+#else
   bool       m_saoInterleavingFlag;   ///< SAO interleaving flag
   bool       m_saoEnabledFlagCb;      ///< SAO Cb enabled flag
   bool       m_saoEnabledFlagCr;      ///< SAO Cr enabled flag
+#endif
   Int         m_iPPSId;               ///< picture parameter set ID
   Bool        m_PicOutputFlag;        ///< pic_output_flag 
@@ -1118,4 +1162,7 @@
 #if LGE_ILLUCOMP_B0045
   Bool        m_bApplyIC;
+#if SHARP_ILLUCOMP_PARSE_D0060
+  Bool        m_icSkipParseFlag;
+#endif
 #endif
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
@@ -1181,4 +1228,8 @@
   Void      setSaoEnabledFlag(Bool s) {m_saoEnabledFlag =s; }
   Bool      getSaoEnabledFlag() { return m_saoEnabledFlag; }
+#if LGE_SAO_MIGRATION_D0091
+  Void      setSaoEnabledFlagChroma(Bool s) {m_saoEnabledFlagChroma =s; }       //!< set SAO Cb&Cr enabled flag
+  Bool      getSaoEnabledFlagChroma() { return m_saoEnabledFlagChroma; }        //!< get SAO Cb&Cr enabled flag
+#else
   Void      setSaoInterleavingFlag(Bool s) {m_saoInterleavingFlag =s; } //!< set SAO interleaving flag
   Bool      getSaoInterleavingFlag() { return m_saoInterleavingFlag;  } //!< get SAO interleaving flag
@@ -1187,4 +1238,5 @@
   Void      setSaoEnabledFlagCr(Bool s) {m_saoEnabledFlagCr =s; }       //!< set SAO Cr enabled flag
   Bool      getSaoEnabledFlagCr() { return m_saoEnabledFlagCr; }        //!< get SAO Cr enabled flag
+#endif
   Void      setRPS          ( TComReferencePictureSet *pcRPS ) { m_pcRPS = pcRPS; }
   TComReferencePictureSet*  getRPS          () { return m_pcRPS; }
@@ -1429,4 +1481,8 @@
   Bool      getApplyIC            ()  { return m_bApplyIC; }
   Void      xSetApplyIC           ();
+#if SHARP_ILLUCOMP_PARSE_D0060
+  Void      setIcSkipParseFlag( Bool b ) { m_icSkipParseFlag = b; }
+  Bool      getIcSkipParseFlag() { return m_icSkipParseFlag; }
+#endif
 #endif
 #if QC_TMVP_MRG_REFIDX_C0047
Index: /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 427)
@@ -84,4 +84,5 @@
                                               // QC_C0051_FIXED_BY_MTK             1   // Bug fix for C0051 implementation
                                               // QC_AMVP_MRG_UNIFY_IVCAN_C0051     1
+#define SEC_TWO_CANDIDATES_FOR_AMVP_D0122 1   // SEC_TWO_CANDIDATES_FOR_AMVP_D0122, fixing # of AMVP candidates 3 to 2
 
 
@@ -151,4 +152,6 @@
 #endif
 
+#define SHARP_ILLUCOMP_PARSE_D0060        1   // JCT3V-D0060 Removal of IC's parsing dependency
+
 ///// ***** INTERVIEW SKIP *********
 #define HHI_INTERVIEW_SKIP                1
@@ -167,4 +170,19 @@
 #define FIX_APPENCTOP_T_ONLY              1   // For Texture-only coding
 
+#define LGE_ROUND_OFFSET_D0135            1   // JCT3V-D0135 Rounding offset
+#define LGE_SAO_MIGRATION_D0091           1
+#if LGE_SAO_MIGRATION_D0091
+#define SAO_SKIP_RIGHT                   1  ///< H1101: disallow using unavailable pixel during RDO
+#define SAO_ENCODING_CHOICE              1  ///< I0184: picture early termination
+#if SAO_ENCODING_CHOICE
+#define SAO_ENCODING_RATE                0.75
+#define SAO_ENCODING_CHOICE_CHROMA       1 ///< J0044: picture early termination Luma and Chroma are handled separatenly
+#if SAO_ENCODING_CHOICE_CHROMA
+#define SAO_ENCODING_RATE_CHROMA         0.5
+#define SAO_ENCODING_CHOICE_CHROMA_BF    1 ///  K0156: Bug fix for SAO selection consistency
+#endif
+#endif
+#endif
+
 ///// ***** FCO  *********
 #define FLEX_CODING_ORDER_M23723          1
@@ -187,7 +205,16 @@
 #if MERL_VSP_C0152
 
+
+#define FIX_MERGE_D                          1 // Fix for merge
 #define MERL_General_Fix                     1 // General fix by MERL
 
+
+
 #define MERL_VSP_C0152_BugFix_ForNoDepthCase 1 // MERL bugfix for test condition of no depth
+#define QC_BVSP_CleanUP_D0191                    1
+
+#define MTK_D0156                 1
+#define LGE_VSP_INHERIT_D0092     1
+
 #define MERL_VSP_COMPENSATION_C0152          1 // JCT3V-C0152: 1: add VSP merge candidate to merging candidate list; 0: not to add (nocand).
 
@@ -198,7 +225,9 @@
 #define MERL_CVSP_D0165                      0 // JCT3V-D0165: 1: enable CVSP; 0: disable CVSP.
 #endif
-
+#if LGE_VSP_INHERIT_D0092
+#define VSP_MERGE_POS                        3 // JCT3V-C0152: fixed position of VSP candidate in merge list, supported values: 3.
+#else
 #define VSP_MERGE_POS                        5 // JCT3V-C0152: fixed position of VSP candidate in merge list, supported values: 5.
-                                               // MTK_DVPREFINE_BVSP_BUG_FIX               1
+#endif                                               // MTK_DVPREFINE_BVSP_BUG_FIX               1
 #define MTK_DEPTH_TO_DISP_D0138              1 // JCT3V-D0138: Use max among four corners for DoNBDV and BVSP
 
@@ -370,6 +399,8 @@
 #define C2FLAG_NUMBER               1 // maximum number of largerThan2 flag coded in one chunk:  16 in HM5
 
+#if !LGE_SAO_MIGRATION_D0091
 #define REMOVE_SAO_LCU_ENC_CONSTRAINTS_1 0  ///< disable the encoder constraint that does not test SAO/BO mode for chroma in interleaved mode
 #define REMOVE_SAO_LCU_ENC_CONSTRAINTS_2 0  ///< disable the encoder constraint that reduce the range of SAO/EO for chroma in interleaved mode
+#endif
 #define REMOVE_SAO_LCU_ENC_CONSTRAINTS_3 0  ///< disable the encoder constraint that conditionally disable SAO for chroma for entire slice in interleaved mode
 #define COLLOCATED_REF_IDX      1           ///< H0442: signal collocated reference index
@@ -644,5 +675,9 @@
   Int         iBestType;
   Int         iLength;
+#if LGE_SAO_MIGRATION_D0091
+  Int         subTypeIdx ;                 ///< indicates EO class or BO band position
+#else
   Int         bandPosition ;
+#endif
   Int         iOffset[4];
   Int         StartCUX;
@@ -674,8 +709,14 @@
   Bool       mergeLeftFlag;
   Int        typeIdx;
+#if LGE_SAO_MIGRATION_D0091
+  Int        subTypeIdx;
+#else
   Int        bandPosition;
+#endif
   Int        offset[4];
+#if !LGE_SAO_MIGRATION_D0091
   Int        runDiff;
   Int        run;
+#endif
   Int        partIdx;
   Int        partIdxTmp;
